import plotly.figure_factory as ff
import plotly.graph_objects as go
import plotly
import json
import os
from decimal import Decimal

dir_path = os.path.dirname(os.path.realpath(__file__))

logcolorscale = [
        [
          0,
          '#482878'
        ],
        [
          0.0001,
          '#482878'
        ],
        [
          0.001,
          '#31688e'
        ],
        [
          0.01,
          '#1f9e89'
        ],
        [
          0.1,
          '#6ece58'
        ],
        [
          1,
          '#fde725'
        ]
      ]

results = []
texts = []
devicesY = []
algorithmsX = [
  'MD5withRSA512', 
  'MD5withRSA768', 
  'MD5withRSA1024', 
  'MD5withRSA2048', 
  'MD5withRSA3072', 
  'MD5withRSA4096']
benchmarkNames = [
  'benchmarkRsa512EcbPKCS1Padding', 'benchmarkRsa768EcbPKCS1Padding', 'benchmarkRsa1024EcbPKCS1Padding', 
  'benchmarkRsa2048EcbPKCS1Padding', 'benchmarkRsa3072EcbPKCS1Padding', 'benchmarkRsa4096EcbPKCS1Padding']

benchmarkClassName = 'cz.vutbr.benchmark.AsymmetricVerifyBenchmark'

for device in os.listdir("{}/results".format(dir_path)):
    filePath = "{}/results/{}/result.json".format(dir_path, device)
    content = open(filePath, "r").read()
    devicesY.append(device)
    decoded = json.loads(content)
    benchmarkResults = decoded['benchmarks']
    result = []
    text = []
    for benchmarkName in benchmarkNames:
      for benchmark in benchmarkResults:
          if benchmark['className'] == benchmarkClassName and benchmark['name'] == benchmarkName:
              metric = benchmark['metrics']['timeNs']['median']
              result.append(metric/1000000)
              text.append('%.2f' % Decimal(metric/1000000))
              break
    results.append(result)
    texts.append(text)

fig = ff.create_annotated_heatmap(results, x=algorithmsX, y=devicesY, annotation_text=texts, colorscale='VIRIDIS', showscale = True)
fig.update_layout(
    xaxis_title="Algorithm",
    yaxis_title="Device",
    autosize=False,
    width=1280,
    height=720,
)
fig['layout']['xaxis']['side'] = 'bottom'
fig['data'][0]['colorbar'].tickformat = ",.1"
fig['data'][0]['colorbar'].ticksuffix = " ms"
fig.write_image("{}/pdf/asymmetric_key_verify_MD5WithRSA.pdf".format(dir_path))